#include "socketcommon.h"

#if _KLIBC_SYS_SOCKETCALL
# define DO_THIS_SOCKETCALL
#else
# if !defined(__NR_getsockname)
#  define DO_THIS_SOCKETCALL
# endif
#endif

#if defined(DO_THIS_SOCKETCALL) && defined(SYS_GETSOCKNAME)

extern long __socketcall(int, const unsigned long *);

int getsockname(int a0, struct sockaddr * a1, socklen_t * a2)
{
    unsigned long args[3];
    args[0] = (unsigned long)a0;
    args[1] = (unsigned long)a1;
    args[2] = (unsigned long)a2;
    return (int) __socketcall(SYS_GETSOCKNAME, args);
}

#endif
