#include "socketcommon.h"

#if _KLIBC_SYS_SOCKETCALL
# define DO_THIS_SOCKETCALL
#else
# if !defined(__NR_getsockopt)
#  define DO_THIS_SOCKETCALL
# endif
#endif

#if defined(DO_THIS_SOCKETCALL) && defined(SYS_GETSOCKOPT)

extern long __socketcall(int, const unsigned long *);

int getsockopt(int a0, int a1, int a2, void * a3, socklen_t * a4)
{
    unsigned long args[5];
    args[0] = (unsigned long)a0;
    args[1] = (unsigned long)a1;
    args[2] = (unsigned long)a2;
    args[3] = (unsigned long)a3;
    args[4] = (unsigned long)a4;
    return (int) __socketcall(SYS_GETSOCKOPT, args);
}

#endif
