#include "socketcommon.h"

#if _KLIBC_SYS_SOCKETCALL
# define DO_THIS_SOCKETCALL
#else
# if !defined(__NR_sendmsg)
#  define DO_THIS_SOCKETCALL
# endif
#endif

#if defined(DO_THIS_SOCKETCALL) && defined(SYS_SENDMSG)

extern long __socketcall(int, const unsigned long *);

int sendmsg(int a0, const struct msghdr * a1, unsigned int a2)
{
    unsigned long args[3];
    args[0] = (unsigned long)a0;
    args[1] = (unsigned long)a1;
    args[2] = (unsigned long)a2;
    return (int) __socketcall(SYS_SENDMSG, args);
}

#endif
