#include "socketcommon.h"

#if _KLIBC_SYS_SOCKETCALL
# define DO_THIS_SOCKETCALL
#else
# if !defined(__NR_socketpair)
#  define DO_THIS_SOCKETCALL
# endif
#endif

#if defined(DO_THIS_SOCKETCALL) && defined(SYS_SOCKETPAIR)

extern long __socketcall(int, const unsigned long *);

int socketpair(int a0, int a1, int a2, int * a3)
{
    unsigned long args[4];
    args[0] = (unsigned long)a0;
    args[1] = (unsigned long)a1;
    args[2] = (unsigned long)a2;
    args[3] = (unsigned long)a3;
    return (int) __socketcall(SYS_SOCKETPAIR, args);
}

#endif
