#include "socketcommon.h"

#if _KLIBC_SYS_SOCKETCALL
# define DO_THIS_SOCKETCALL
#else
# if !defined(__NR_listen)
#  define DO_THIS_SOCKETCALL
# endif
#endif

#if defined(DO_THIS_SOCKETCALL) && defined(SYS_LISTEN)

extern long __socketcall(int, const unsigned long *);

int listen(int a0, int a1)
{
    unsigned long args[2];
    args[0] = (unsigned long)a0;
    args[1] = (unsigned long)a1;
    return (int) __socketcall(SYS_LISTEN, args);
}

#endif
