#include "socketcommon.h"

#if _KLIBC_SYS_SOCKETCALL
# define DO_THIS_SOCKETCALL
#else
# if !defined(__NR_recvfrom)
#  define DO_THIS_SOCKETCALL
# endif
#endif

#if defined(DO_THIS_SOCKETCALL) && defined(SYS_RECVFROM)

extern long __socketcall(int, const unsigned long *);

int recvfrom(int a0, void * a1, size_t a2, unsigned int a3, struct sockaddr * a4, socklen_t * a5)
{
    unsigned long args[6];
    args[0] = (unsigned long)a0;
    args[1] = (unsigned long)a1;
    args[2] = (unsigned long)a2;
    args[3] = (unsigned long)a3;
    args[4] = (unsigned long)a4;
    args[5] = (unsigned long)a5;
    return (int) __socketcall(SYS_RECVFROM, args);
}

#endif
